<template>
  <fieldset class="Dropdown">
    <label v-if="label" :for="uuid + '_select'" class="Dropdown__Label">
      {{ label }}
    </label>
    <!--suppress HtmlFormInputWithoutLabel -->
    <select
      :id="uuid + '_select'"
      :value="modelValue"
      class="Dropdown__Control"
      @input="$emit('update:modelValue', $event.target.value)"
    >
      <option v-for="(value, label) in options" :key="label" :value="value">
        {{ noTranslate ? label : t(label) }}
      </option>
    </select>
    <Button
      v-if="isRestorable"
      :icon="Icons.restore"
      :title="t('component.restore')"
      class="Dropdown__Restore Button--noBorder"
      @click="$emit('update:modelValue', restoreValue)"
    />
  </fieldset>
</template>

<script lang="ts">
import { defineComponent, getCurrentInstance, inject, PropType } from 'vue'
import { Icons } from '@/Icons'
import Button from '@/components/Button.vue'

export default defineComponent({
  name: 'Dropdown',
  components: { Button },
  emits: ['update:modelValue'],
  props: {
    label: String,
    modelValue: null,
    restoreValue: null,
    options: Object as PropType<Record<string, object>>,
    noTranslate: Boolean,
  },

  setup() {
    return {
      Icons,
      t: inject('t', (str: unknown) => str),
    }
  },

  computed: {
    isRestorable(): boolean {
      return this.restoreValue && this.restoreValue !== this.modelValue
    },
    uuid(): number {
      const cid = getCurrentInstance()
      if (cid) return cid.uid
      return -1
    },
  },
})
</script>

<style lang="scss" scoped>
@use '../../style/variables';

.Dropdown {
  border: none;
}
</style>
